var mainW;
var needShow = true;
var loaded = false;
var uri2load = '/login?inApp=1';
var devReady = false;
var gotAuth = false;

var ajax = {
  post: function(url, args, _callback) {
    var q = new XMLHttpRequest();
    q.open(/*method*/ 'POST', url, /*async*/ true);
    q.onreadystatechange = function() {
      if (this.readyState == 4 && this.status == 200) {
        _callback(this.responseText);
      }
    };
    q.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
    q.send(args);
  }
};

var app = {
  // Application Constructor
  initialize: function() {
    document.addEventListener(
        'deviceready', this.onDeviceReady.bind(this), false);
    document.addEventListener('online', this.onOnline.bind(this), false);
    document.addEventListener('pause', this.onPause.bind(this), false);
    document.addEventListener('resume', this.onResume.bind(this), false);
  },

  // deviceready Event Handler
  onDeviceReady: function() {
    var a = this;
    FCMPlugin.onNotification(
        this.onPushNotify,
        function(msg) {
          console.log(
              'onNotification callback successfully registered: ' + msg);
          a.receivedEvent('deviceready');
          devReady = true;
        },
        function(err) {
          console.log('Error registering onNotification callback: ' + err);
          a.receivedEvent('deviceready');
          devReady = true;
        });
  },

  onOnline: function() {
    if (!devReady) {
      return;
    }
    this.receivedEvent('online');
  },

  setFcmToken: function() {

    FCMPlugin.getToken(
        function(token) {
          if (token == null) {
            setTimeout(app.setFcmToken, 1000);
          } else {
            cookieMaster.setCookieValue(
                'https://homebeat.live', 'ftoken', 'token', function() {},
                function(error) {});
          }
        },
        function(err) { setTimeout(app.setFcmToken, 5000); });
  },

  // Update DOM on a Received Event
  receivedEvent: function(id) {

    if (loaded) {
      return;
    }

    cordova.plugins.notification.badge.configure({autoClear: true});

    this.setFcmToken();

    var parentElement = document.getElementById('deviceready');
    var listeningElement = parentElement.querySelector('.listening');
    var receivedElement = parentElement.querySelector('.received');
    var conElement = parentElement.querySelector('.noconnection');

    listeningElement.setAttribute('style', 'display:none;');

    if (navigator.connection.type == Connection.NONE) {
      conElement.setAttribute('style', 'display:block;');
      receivedElement.setAttribute('style', 'display:none;');
    } else {
      this.openPage(uri2load);
    }
  },

  openPage: function(uri) {
    console.log('openPage: ' + uri);

    if (undefined != mainW) {
      mainW.removeEventListener('exit', this.onIBExit.bind(this));
      mainW.hide();
    }



    cookieMaster.setCookieValue(
        'https://homebeat.live', 'cookies_confirm', '1', function() {},
        function(error) {});
    cookieMaster.setCookieValue(
          'https://homebeat.live', 'in_app', '1', function() {},
          function(error) {});
  
    mainW = cordova.InAppBrowser.open(
        'https://homebeat.live' + uri, '_blank',
        'location=no,toolbar=no,hidden=yes,zoom=no');

    mainW.executeScript({code: 'window.HBL_inApp = true'});

    var parentElement = document.getElementById('deviceready');
    var receivedElement = parentElement.querySelector('.received');
    var conElement = parentElement.querySelector('.noconnection');

    receivedElement.setAttribute('style', 'display:block;');
    conElement.setAttribute('style', 'display:none;');

    mainW.addEventListener('loadstart', this.loadStart.bind(this), false);
    mainW.addEventListener('loadstop', this.loadStop.bind(this), false);
    mainW.addEventListener('exit', this.onIBExit.bind(this), false);

    loaded = true;
  },

  loadStart: function(event) { console.log('start: ' + event.url); },

  checkAuth: function() {
    // check authtoken :)
    cookieMaster.getCookieValue(
        'https://homebeat.live', 'authtoken',
        function(data) {
          console.log('auth: ' + data.cookieValue);
          FCMPlugin.getToken(
              function(token) {
                if (token == null) {
                  setTimeout(app.checkAuth, 1000);
                } else {
                  gotAuth = true;
                  // console.log("token: " + token);
                  ajax.post(
                      'https://homebeat.live/v1/fcm',
                      'uuid=' + encodeURIComponent(device.uuid) + '&token=' +
                          encodeURIComponent(token) + '&platform=' +
                          encodeURIComponent(device.platform) +
                          encodeURIComponent(device.version),
                      function(r) {});
                }
              },
              function(err) {
                console.log('error retrieving token: ' + err);
                setTimeout(app.checkAuth, 5000);
              })
        },
        function(error) {
          // console.log("waiting...");
          setTimeout(app.checkAuth, 1000);
        });

  },

  loadStart: function(event) {
    if ((gotAuth) && (device.platform != 'iOS')) {
      if (event.url == 'https://homebeat.live/login') {
        mainW.hide();
        navigator.app.exitApp();
      }
    }
  },

  loadStop: function(event) {
    if (needShow) {
      if (mainW != undefined) {
        needShow = false;
        var parentElement = document.getElementById('deviceready');
        var receivedElement = parentElement.querySelector('.received');
        receivedElement.setAttribute('style', 'display:none;');
        mainW.show();
        this.checkAuth();
        setTimeout(function() {
          document.body.style.background = '#000000';
        }, 250);
      }
    }
  },

  onIBExit: function() { navigator.app.exitApp(); },

  onPause: function() {
    if (undefined != mainW) {
      mainW.executeScript({code: 'appPause()'});
    }
  },
  onResume: function() {
    if (undefined != mainW) {
      mainW.executeScript({code: 'appResume()'});
    }
  },

  onPushNotify: function(data) {
    // ignore messages in foreground
    if (data.wasTapped) {
      uri2load = data.uri;
      if (undefined != mainW) {
        mainW.executeScript({
          code: 'window.location = "' +
              'https://homebeat.live' + data.uri + '"'
        });
      }
    }
  }

};

app.initialize();